function usersym_scale, dummy
	osfam = !version.os_family
	if (osfam eq 'MacOS') then begin
		scaler = 1.0
	endif else begin 
		if (osfam eq 'unix') then begin
			scaler = 0.5
		endif else begin
			; No idea how things will render under Windoze, split the difference...
			scaler = 0.75
		endelse
	endelse
	return,scaler
end

function iswindows, dummy
	osfam = !version.os_family
	if (osfam ne 'MacOS') then begin
		iswin = 1
	endif else begin
		iswin = 0
	endelse
	return,iswin
end

function isonlywindows, dummy
	osfam = !version.os_family
	if (osfam eq 'Windows') then begin
		iswin = 1
	endif else begin
		iswin = 0
	endelse
	return,iswin
end
	
function compatible_pickfile,version,filter=filter,must_exist=must_exist,read=read,write=write,title=title
	common paths, lastpath, currentpath, origpath, shlbfile
	common fullpaths, app_path, data_path, bg_path, output_path

	
	if (keyword_set(read)) then begin
		setorig = 0
		if (lastpath eq '') then begin
			pathstr = ''
			setorig = 1
		endif else begin
			pathstr = ',path="'+lastpath+'"'
		endelse
	endif else begin
		pathstr = ',path="'+output_path+'"'
	endelse
	version = fix(!version.release)
	if (version eq 4) then begin
		picstr = 'fname = pickfile(/noconfirm,get_path=newcurrentpath'
	endif else begin
		picstr = 'fname = dialog_pickfile(/noconfirm,get_path=newcurrentpath'
	endelse
	
	if keyword_set(filter) then begin
			picstr = picstr + ',filter="' + filter+'"'
	endif
	if keyword_set(must_exist) then begin
			picstr = picstr + ',/must_exist'
	endif
	if keyword_set(read) then begin
			picstr = picstr + ',/read'
	endif
	if keyword_set(write) then begin
			picstr = picstr + ',/write'
	endif
	if keyword_set(title) then begin
			picstr = picstr + ',title="' + title + '"'
	endif
	picstr = picstr + pathstr
	picstr = picstr + ')'
	result = execute(picstr)
	if (fname ne '') then begin
;		print,'*'+fname+'*'
		if keyword_set(read) then begin
			currentpath = newcurrentpath
			lastpath = newcurrentpath
			data_path = newcurrentpath
		endif
		return, fname
	endif else begin
		return,''
	endelse
end
	
function make_readstring,fname,sensor
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common lisapp_prefs, app_prefs

	if (app_prefs.shlb.use_shlb eq 1) then begin
		shlbname=strip_132(app_prefs.shlb.shlb)
		use_shlb = 1
	endif else begin
		use_shlb = 0
	endelse 
	
	if (sensor eq 'lis') then begin
		readstring = 'read_orbit,"'+fname+'",orbit'
		useparams = readparams
	endif else begin
		readstring = 'read_old_orbit,"'+fname+'",orbit,old_orbit'
		useparams = readparamsotd
	endelse
	
	if (useparams(0) ne 1) then readstring = readstring + ',/no_areas'
	if (useparams(1) ne 1) then readstring = readstring + ',/no_flashes'
	if (useparams(2) ne 1) then readstring = readstring + ',/no_groups'
	if (useparams(3) ne 1) then readstring = readstring + ',/no_events'
	if (useparams(4) ne 1) then readstring = readstring + ',/no_viewtimes'
	if (useparams(5) ne 1) then readstring = readstring + ',/no_one_seconds'
	if (use_shlb) then begin
		readstring = readstring+',native="'+shlbname+'"'
	endif
	
;	print, readstring
	
	return,readstring
end

function determine_sensor
	common prefs, readparams, readparamsotd, setparams, setparamsotd, gotparams, gotparamsotd
	common datafiles, orbit, fname
	
	notyet = 1
	if (gotparams(5) eq 1) then begin
		goodsec = max(orbit.one_second(*).TAI93_time)
		if (goodsec lt 154728004.000D) then begin
			retval='otd'
			notyet = 0
		endif else begin
			notyet = 1
		endelse
	endif
	if (notyet eq 1) then begin
		if (gotparams(4) eq 1) then begin
			maybeotd = where((abs(orbit.point.viewtime(*).location(0)) gt 40) and $
						 (abs(orbit.point.viewtime(*).location(0)) lt 70))
		endif else begin
			if (gotparams(3) eq 1) then begin
				maybeotd = where((abs(orbit.point.lightning.event(*).location(0)) gt 40) and $
							 (abs(orbit.point.lightning.event(*).location(0)) lt 70))    
			endif else begin
				if (gotparams(2) eq 1) then begin
					maybeotd = where((abs(orbit.point.lightning.group(*).location(0)) gt 40) and $
							      (abs(orbit.point.lightning.group(*).location(0)) lt 70))
				endif else begin
					if (gotparams(1) eq 1) then begin
						maybeotd = where((abs(orbit.point.lightning.flash(*).location(0)) gt 40) and $
									 (abs(orbit.point.lightning.flash(*).location(0)) lt 70))
					endif else begin
						if (gotparams(0) eq 1) then begin
							maybeotd = where((abs(orbit.point.lightning.area(*).location(0)) gt 40) and $
									      (abs(orbit.point.lightning.area(*).location(0)) lt 70))
						endif else begin
							maybeotd = -1
						endelse
					endelse
				endelse
			endelse
		endelse
		
		szmaybeotd = size(maybeotd)
		
		if (szmaybeotd(0) le 0) then begin
			retval = 'lis'
		endif else begin
			retval = 'otd'
		endelse
	endif
		
;	print,'***',retval,'***'
	return,retval
end

pro selfkill, event
	widget_control,event.top,/destroy
end

pro get_pointing_vector, sensor, xpix, ypix, look_vector

	coeff = dblarr(4)
	
	if (sensor eq 'lis') then begin
		coeff = [1.4754537D, -.36224695D, -.088939824D, -.28203806D]
		x = (63.5-xpix)/127.
		y = (ypix-63.5)/127.
	endif else begin
		if (sensor eq 'otd') then begin
			coeff = [1.4037314D, .015948348D, -.86702375D, .24905820D]
			x=(xpix-63.5)/127.
			y=(63.5-ypix)/127.
		endif else begin
			print, 'Unknown sensor '+sensor
			stop
		endelse
	endelse
	
	; **** ORIGINAL ****
	
;	 x = (xpix - 63.5)/127.
;	 y = (127-ypix-63.5)/127.
	
	xy = sqrt(x*x+y*y)
		
	convert = coeff(0) + xy*(coeff(1)+xy*(coeff(2)+xy*(coeff(3))))
	
	look_vector = dblarr(3)
	
	look_vector(0) = x*convert
	look_vector(1) = y*convert
	look_vector(2) = sqrt(1.-(look_vector(0)*look_vector(0) + look_vector(1)*look_vector(1)))
		
end





pro get_vector_pointing_vector, sensor, xpix, ypix, look_vector

	coeff = dblarr(4)
	
	if (sensor eq 'lis') then begin
		coeff = [1.4754537D, -.36224695D, -.088939824D, -.28203806D]
		x = (63.5-xpix)/127.
		y = (ypix-63.5)/127.
	endif else begin
		if (sensor eq 'otd') then begin
			coeff = [1.4037314D, .015948348D, -.86702375D, .24905820D]
			x=(xpix-63.5)/127.
			y=(63.5-ypix)/127.
		endif else begin
			print, 'Unknown sensor '+sensor
			stop
		endelse
	endelse
	
	; **** ORIGINAL ****
	
;	 x = (xpix - 63.5)/127.
;	 y = (127-ypix-63.5)/127.
	
	xy = sqrt(x*x+y*y)
	
	;print,min(xy),max(xy)
	convert = coeff(0) + xy*(coeff(1)+xy*(coeff(2)+xy*(coeff(3))))
	
	vsize = size(xpix)
	vlen = vsize(1)
	
	look_vector = dblarr(vlen,3)
	
	look_vector(*,0) = x*convert
	look_vector(*,1) = y*convert
	look_vector(*,2) = sqrt(1.-(look_vector(*,0)*look_vector(*,0) + look_vector(*,1)*look_vector(*,1)))
	
end

pro get_array_pointing_vector, sensor, array_look_vector

	array_look_vector = dblarr(128,128,3)

		coeff = dblarr(4)
	
	xpix = fltarr(128,128)
	ypix = fltarr(128,128)
	
	for i=0,127,1 do begin
		xpix(i,*) = float(i)
		ypix(*,i) = float(i)
	endfor

	if (sensor eq 'lis') then begin
		coeff = [1.4754537D, -.36224695D, -.088939824D, -.28203806D]
		x = (63.5-xpix)/127.
		y = (ypix-63.5)/127.
	endif else begin
		if (sensor eq 'otd') then begin
			coeff = [1.4037314D, .015948348D, -.86702375D, .24905820D]
			x=(xpix-63.5)/127.
			y=(63.5-ypix)/127.
		endif else begin
			print, 'Unknown sensor '+sensor
			stop
		endelse
	endelse
	
	; **** ORIGINAL ****
	
	; x = (xpix - 63.5)/127.
	; y = (127-ypix-63.5)/127.
			
	xy = sqrt(x*x+y*y)
	
	;print,min(xy),max(xy)
	convert = coeff(0) + xy*(coeff(1)+xy*(coeff(2)+xy*(coeff(3))))
	
	array_look_vector = dblarr(128,128,3)
	
	array_look_vector(*,*,0) = x*convert
	array_look_vector(*,*,1) = y*convert
	array_look_vector(*,*,2) = sqrt(1.-(array_look_vector(*,*,0)*array_look_vector(*,*,0) + array_look_vector(*,*,1)*array_look_vector(*,*,1)))
	
end
	
	

pro get_earth_intersection, look_vector, time, location, parallax, return_code

	common datafiles, orbit, fname

	lookunitvec = dblarr(3)
	LookECR = dblarr(3)
	location = dblarr(2)
	
	; Add 12 km parallax correction
	
	axis_A = 6378137.0D + parallax
	axis_C = 6356752.31D + parallax
	axrat  = 0.99664714532D
	
	axis_SqA = axis_A*axis_A
	axis_SqB = axis_SqA
	axis_SqC = axis_C*axis_C
	
	tidx = long(time-orbit.one_second(0).TAI93_time)
	transform_matrix = dblarr(9)
	position_vector = dblarr(3)
	
	intfrac = time-long(time)
	for i=0,8,1 do begin
		transform_matrix(i) = ((orbit.one_second(tidx+1).transform_matrix(i)-orbit.one_second(tidx).transform_matrix(i))*intfrac) + $
						 (orbit.one_second(tidx).transform_matrix(i))
	endfor
	for i=0,2,1 do begin
		position_vector(i) = ((orbit.one_second(tidx+1).position_vector(i)-orbit.one_second(tidx).position_vector(i))*intfrac) + $
						(orbit.one_second(tidx).position_vector(i))
	endfor
	
	lookunitvec(0) = transform_matrix(0) * look_vector(0) + $
				 transform_matrix(1) * look_vector(1) + $
				 transform_matrix(2) * look_vector(2)
	lookunitvec(1) = transform_matrix(3) * look_vector(0) + $
	 			 transform_matrix(4) * look_vector(1) + $
	 			 transform_matrix(5) * look_vector(2)
	lookunitvec(2) = transform_matrix(6) * look_vector(0) + $
				 transform_matrix(7) * look_vector(1) + $
				 transform_matrix(8) * look_vector(2)
	
	normlookunitvec = sqrt(lookunitvec(0)*lookunitvec(0) + lookunitvec(1)*lookunitvec(1) + lookunitvec(2)*lookunitvec(2))
	
	lookunitvec(0) = lookunitvec(0) / normlookunitvec
	lookunitvec(1) = lookunitvec(1) / normlookunitvec
	lookunitvec(2) = lookunitvec(2) / normlookunitvec
	
	aCoef = lookunitvec(0)*lookunitvec(0) / axis_SqA + $
		   lookunitvec(1)*lookunitvec(1) / axis_SqB + $
		   lookunitvec(2)*lookunitvec(2) / axis_SqC
		   
	bCoef = 2.0D * (position_vector(0) * lookunitvec(0) / axis_SqA + $
			     position_vector(1) * lookunitvec(1) / axis_SqB + $
			     position_vector(2) * lookunitvec(2) / axis_SqC)
			     
	cCoef = -1.0D + position_vector(0)*position_vector(0) / axis_SqA + $
				position_vector(1)*position_vector(1) / axis_SqB + $
				position_vector(2)*position_vector(2) / axis_SqC
				
	radical = bCoef*bCoef - 4.0D*aCoef*cCoef
	
	if ((aCoef le 0.0) or (radical lt 0.0)) then begin
		slantRange = 0D
		location(0) = 90D
		location(1) = 90D
		return_code = -1
	endif else begin
		slantRange = (-1.0D*bCoef - sqrt(radical))/(2.0D*aCoef)
		LookECR(0) = position_vector(0) + slantRange * lookunitvec(0)
		LookECR(1) = position_vector(1) + slantRange * lookunitvec(1)
		LookECR(2) = position_vector(2) + slantRange * lookunitvec(2)
		location(1) = 180.0D / double(!PI) * atan(LookECR(1),LookECR(0))
		location(0) = 180.0D / double(!PI) * atan(LookECR(2), axrat*axrat * sqrt(LookECR(0)*LookECR(0) + LookECR(1)*LookECR(1)))
		return_code = 0
	endelse
	
	tidx = 0 & transform_matrix = 0 & position_vector = 0
end

pro get_ionosphere_intersection, look_vector, time, location, parallax, return_code

	common datafiles, orbit, fname

	lookunitvec = dblarr(3)
	LookECR = dblarr(3)
	location = dblarr(2)
	
	axis_A = 6378137.0D + parallax
	axis_C = 6356752.31D + parallax
	axrat  = 0.99664714532D
	
	axis_SqA = axis_A*axis_A
	axis_SqB = axis_SqA
	axis_SqC = axis_C*axis_C
	
	tidx = long(time-orbit.one_second(0).TAI93_time)
	
	lookunitvec(0) = orbit.one_second(tidx).transform_matrix(0) * look_vector(0) + $
				 orbit.one_second(tidx).transform_matrix(1) * look_vector(1) + $
				 orbit.one_second(tidx).transform_matrix(2) * look_vector(2)
	lookunitvec(1) = orbit.one_second(tidx).transform_matrix(3) * look_vector(0) + $
	 			 orbit.one_second(tidx).transform_matrix(4) * look_vector(1) + $
	 			 orbit.one_second(tidx).transform_matrix(5) * look_vector(2)
	lookunitvec(2) = orbit.one_second(tidx).transform_matrix(6) * look_vector(0) + $
				 orbit.one_second(tidx).transform_matrix(7) * look_vector(1) + $
				 orbit.one_second(tidx).transform_matrix(8) * look_vector(2)
	
	normlookunitvec = sqrt(lookunitvec(0)*lookunitvec(0) + lookunitvec(1)*lookunitvec(1) + lookunitvec(2)*lookunitvec(2))
	
	lookunitvec(0) = lookunitvec(0) / normlookunitvec
	lookunitvec(1) = lookunitvec(1) / normlookunitvec
	lookunitvec(2) = lookunitvec(2) / normlookunitvec
	
	aCoef = lookunitvec(0)*lookunitvec(0) / axis_SqA + $
		   lookunitvec(1)*lookunitvec(1) / axis_SqB + $
		   lookunitvec(2)*lookunitvec(2) / axis_SqC
		   
	bCoef = 2.0D * (orbit.one_second(tidx).position_vector(0) * lookunitvec(0) / axis_SqA + $
			     orbit.one_second(tidx).position_vector(1) * lookunitvec(1) / axis_SqB + $
			     orbit.one_second(tidx).position_vector(2) * lookunitvec(2) / axis_SqC)
			     
	cCoef = -1.0D + orbit.one_second(tidx).position_vector(0)*orbit.one_second(tidx).position_vector(0) / axis_SqA + $
				orbit.one_second(tidx).position_vector(1)*orbit.one_second(tidx).position_vector(1) / axis_SqB + $
				orbit.one_second(tidx).position_vector(2)*orbit.one_second(tidx).position_vector(2) / axis_SqC
				
	radical = bCoef*bCoef - 4.0D*aCoef*cCoef
	
	if ((aCoef le 0.0) or (radical lt 0.0)) then begin
		slantRange = 0D
		location(0) = 90D
		location(1) = 90D
		return_code = -1
	endif else begin
		slantRange = (-1.0D*bCoef - sqrt(radical))/(2.0D*aCoef)
		LookECR(0) = orbit.one_second(tidx).position_vector(0) + slantRange * lookunitvec(0)
		LookECR(1) = orbit.one_second(tidx).position_vector(1) + slantRange * lookunitvec(1)
		LookECR(2) = orbit.one_second(tidx).position_vector(2) + slantRange * lookunitvec(2)
		location(1) = 180.0D / double(!PI) * atan(LookECR(1),LookECR(0))
		location(0) = 180.0D / double(!PI) * atan(LookECR(2), axrat*axrat * sqrt(LookECR(0)*LookECR(0) + LookECR(1)*LookECR(1)))
		return_code = 0
	endelse
	tidx = 0 & transform_matrix = 0 & position_vector = 0
end

pro get_vector_earth_intersection, look_vector, time, vector_location, parallax, return_code

	common datafiles, orbit, fname
	
	vsize = size(look_vector)
	vlen = vsize(1)
	
	lookunitvec = dblarr(vlen,3)
	LookECR = dblarr(vlen,3)
	vector_location = dblarr(vlen,2)
	tidx = lonarr(vlen)
	
	tidx = long(time-orbit.one_second(0).TAI93_time)
	transform_matrix = dblarr(vlen,9)
	position_vector = dblarr(vlen,3)
	
	intfrac = time-long(time)
	for i=0,8,1 do begin
		transform_matrix(*,i) = ((orbit.one_second(tidx+1).transform_matrix(i)-orbit.one_second(tidx).transform_matrix(i))*intfrac) + $
						 (orbit.one_second(tidx).transform_matrix(i))
	endfor
	for i=0,2,1 do begin
		position_vector(*,i) = ((orbit.one_second(tidx+1).position_vector(i)-orbit.one_second(tidx).position_vector(i))*intfrac) + $
						(orbit.one_second(tidx).position_vector(i))
	endfor

	; Add 12 km parallax correction
	
	axis_A = 6378137.0D + parallax
	axis_C = 6356752.31D + parallax
	axrat  = 0.99664714532D
	
	axis_SqA = axis_A*axis_A
	axis_SqB = axis_SqA
	axis_SqC = axis_C*axis_C
	
	
	goodtimes = where(tidx ge 0 and tidx lt orbit.orbit_summary.one_second_count,goodct)
	; print,goodct
	if (goodct lt vlen) then begin
		badtimes = where(tidx lt 0 or tidx ge orbit.orbit_summary.one_second_count)
		vector_location(badtimes,0) = 90D
		vector_location(badtimes,1) = 90D
	endif
	if (goodct gt 0) then begin
	
		lookunitvec(goodtimes,0) = transform_matrix(goodtimes,0) * look_vector(goodtimes,0) + $
						transform_matrix(goodtimes,1) * look_vector(goodtimes,1) + $
					 	transform_matrix(goodtimes,2) * look_vector(goodtimes,2)
		lookunitvec(goodtimes,1) = transform_matrix(goodtimes,3) * look_vector(goodtimes,0) + $
		 			 	transform_matrix(goodtimes,4) * look_vector(goodtimes,1) + $
		 			 	transform_matrix(goodtimes,5) * look_vector(goodtimes,2)
		lookunitvec(goodtimes,2) = transform_matrix(goodtimes,6) * look_vector(goodtimes,0) + $
					 	transform_matrix(goodtimes,7) * look_vector(goodtimes,1) + $
					 	transform_matrix(goodtimes,8) * look_vector(goodtimes,2)
		
		normlookunitvec = sqrt(lookunitvec(goodtimes,0)*lookunitvec(goodtimes,0) + lookunitvec(goodtimes,1)*lookunitvec(goodtimes,1) + $
							lookunitvec(goodtimes,2)*lookunitvec(goodtimes,2))
		
		lookunitvec(goodtimes,0) = lookunitvec(goodtimes,0) / normlookunitvec
		lookunitvec(goodtimes,1) = lookunitvec(goodtimes,1) / normlookunitvec
		lookunitvec(goodtimes,2) = lookunitvec(goodtimes,2) / normlookunitvec
		
		aCoef = lookunitvec(goodtimes,0)*lookunitvec(goodtimes,0) / axis_SqA + $
			   lookunitvec(goodtimes,1)*lookunitvec(goodtimes,1) / axis_SqB + $
			   lookunitvec(goodtimes,2)*lookunitvec(goodtimes,2) / axis_SqC
			   
		bCoef = 2.0D * (position_vector(goodtimes,0) * lookunitvec(goodtimes,0) / axis_SqA + $
				     position_vector(goodtimes,1) * lookunitvec(goodtimes,1) / axis_SqB + $
				     position_vector(goodtimes,2) * lookunitvec(goodtimes,2) / axis_SqC)
				     
		cCoef = -1.0D + position_vector(goodtimes,0)*position_vector(goodtimes,0) / axis_SqA + $
					position_vector(goodtimes,1)*position_vector(goodtimes,1) / axis_SqB + $
					position_vector(goodtimes,2)*position_vector(goodtimes,2) / axis_SqC
					
		radical = bCoef*bCoef - 4.0D*aCoef*cCoef
		
		badgeo = where(aCoef le 0.0 and radical lt 0.0,badgct)
		goodgeo = where(aCoef gt 0.0 and radical ge 0.0,goodgct)
		
		if (goodgct lt goodct) then begin
			slantRange = 0D
			if (badgct ge 1) then begin
				vector_location(goodtimes(badgeo),0) = 90D
				vector_location(goodtimes(badgeo),1) = 90D
			endif
			return_code = -1
		endif
		if (goodgct gt 0) then begin
			slantRange = (-1.0D*bCoef - sqrt(radical))/(2.0D*aCoef)
			LookECR(goodtimes(goodgeo),0) = position_vector(goodtimes(goodgeo),0) + slantRange * lookunitvec(goodtimes(goodgeo),0)
			LookECR(goodtimes(goodgeo),1) = position_vector(goodtimes(goodgeo),1) + slantRange * lookunitvec(goodtimes(goodgeo),1)
			LookECR(goodtimes(goodgeo),2) = position_vector(goodtimes(goodgeo),2) + slantRange * lookunitvec(goodtimes(goodgeo),2)
			vector_location(goodtimes(goodgeo),1) = 180.0D / double(!PI) * atan(LookECR(goodtimes(goodgeo),1),LookECR(goodtimes(goodgeo),0))
			vector_location(goodtimes(goodgeo),0) = 180.0D / double(!PI) * atan(LookECR(goodtimes(goodgeo),2), axrat*axrat * sqrt(LookECR(goodtimes(goodgeo),0)*$
										LookECR(goodtimes(goodgeo),0) + LookECR(goodtimes(goodgeo),1)*LookECR(goodtimes(goodgeo),1)))
			return_code = 0
		endif
	endif
	tidx = 0 & transform_matrix = 0 & position_vector = 0
end

pro get_array_earth_intersection, look_vector, time, array_location, parallax, return_code

	common datafiles, orbit, fname

	lookunitvec = dblarr(128,128,3)
	LookECR = dblarr(128,128,3)
	array_location = dblarr(128,128,2)
	
	; No cloud-top correction; assume all array intersections are bgs to be geolocated at surface
	
	axis_A = 6378137.0D + parallax
	axis_C = 6356752.31D + parallax
	axrat  = 0.99664714532D
	
	axis_SqA = axis_A*axis_A
	axis_SqB = axis_SqA
	axis_SqC = axis_C*axis_C
	
	tidx = long(time-orbit.one_second(0).TAI93_time)
	transform_matrix = dblarr(9)
	position_vector = dblarr(3)
	
	intfrac = time-long(time)
	for i=0,8,1 do begin
		transform_matrix(i) = ((orbit.one_second(tidx+1).transform_matrix(i)-orbit.one_second(tidx).transform_matrix(i))*intfrac) + $
						 (orbit.one_second(tidx).transform_matrix(i))
	endfor
	for i=0,2,1 do begin
		position_vector(i) = ((orbit.one_second(tidx+1).position_vector(i)-orbit.one_second(tidx).position_vector(i))*intfrac) + $
						(orbit.one_second(tidx).position_vector(i))
	endfor
	
	if (tidx lt 0 or tidx ge orbit.orbit_summary.one_second_count) then begin
		slantRange = 0D
		array_location(0) = 90D
		array_location(1) = 90D
		return_code = -1
	endif else begin
		lookunitvec(*,*,0) = transform_matrix(0) * look_vector(*,*,0) + $
						transform_matrix(1) * look_vector(*,*,1) + $
					 	transform_matrix(2) * look_vector(*,*,2)
		lookunitvec(*,*,1) = transform_matrix(3) * look_vector(*,*,0) + $
		 			 	transform_matrix(4) * look_vector(*,*,1) + $
		 			 	transform_matrix(5) * look_vector(*,*,2)
		lookunitvec(*,*,2) = transform_matrix(6) * look_vector(*,*,0) + $
					 	transform_matrix(7) * look_vector(*,*,1) + $
					 	transform_matrix(8) * look_vector(*,*,2)
		
		normlookunitvec = sqrt(lookunitvec(*,*,0)*lookunitvec(*,*,0) + lookunitvec(*,*,1)*lookunitvec(*,*,1) + lookunitvec(*,*,2)*lookunitvec(*,*,2))
		
		lookunitvec(*,*,0) = lookunitvec(*,*,0) / normlookunitvec
		lookunitvec(*,*,1) = lookunitvec(*,*,1) / normlookunitvec
		lookunitvec(*,*,2) = lookunitvec(*,*,2) / normlookunitvec
		
		aCoef = lookunitvec(*,*,0)*lookunitvec(*,*,0) / axis_SqA + $
			   lookunitvec(*,*,1)*lookunitvec(*,*,1) / axis_SqB + $
			   lookunitvec(*,*,2)*lookunitvec(*,*,2) / axis_SqC
			   
		bCoef = 2.0D * (position_vector(0) * lookunitvec(*,*,0) / axis_SqA + $
				     position_vector(1) * lookunitvec(*,*,1) / axis_SqB + $
				     position_vector(2) * lookunitvec(*,*,2) / axis_SqC)
				     
		cCoef = -1.0D + position_vector(0)*position_vector(0) / axis_SqA + $
					position_vector(1)*position_vector(1) / axis_SqB + $
					position_vector(2)*position_vector(2) / axis_SqC
					
		radical = bCoef*bCoef - 4.0D*aCoef*cCoef
		
		if ((min(aCoef) le 0.0) or (min(radical) lt 0.0)) then begin
			slantRange = 0D
			array_location(0) = 90D
			array_location(1) = 90D
			return_code = -1
		endif else begin
			slantRange = (-1.0D*bCoef - sqrt(radical))/(2.0D*aCoef)
			LookECR(*,*,0) = position_vector(0) + slantRange * lookunitvec(*,*,0)
			LookECR(*,*,1) = position_vector(1) + slantRange * lookunitvec(*,*,1)
			LookECR(*,*,2) = position_vector(2) + slantRange * lookunitvec(*,*,2)
			array_location(*,*,1) = 180.0D / double(!PI) * atan(LookECR(*,*,1),LookECR(*,*,0))
			array_location(*,*,0) = 180.0D / double(!PI) * atan(LookECR(*,*,2), axrat*axrat * sqrt(LookECR(*,*,0)*LookECR(*,*,0) + LookECR(*,*,1)*LookECR(*,*,1)))
			return_code = 0
		endelse
	endelse
	tidx = 0 & transform_matrix = 0 & position_vector = 0
end


pro get_nadir_location, time, location

	common datafiles, orbit, fname

	location = dblarr(2)
	
	axrat = .99664714532D
	
	tidx = long(time-orbit.one_second(0).TAI93_time)
	
	location(1) = 180.0D / double(!PI) * atan(orbit.one_second(tidx).position_vector(1), orbit.one_second(tidx).position_vector(0))
	location(0) = 180.0D / double(!PI) * atan(orbit.one_second(tidx).position_vector(2), $
								     axrat*axrat*sqrt(orbit.one_second(tidx).position_vector(0)*orbit.one_second(tidx).position_vector(0) + $
								     			      orbit.one_second(tidx).position_vector(1)*orbit.one_second(tidx).position_vector(1)))
end

pro get_nadir_locations, times, locations

	common datafiles, orbit, fname

	tidxs = long(times-orbit.one_second(*).TAI93_time)
	goodtidxs = where((tidxs ge 0) and (tidxs lt orbit.orbit_summary.one_second_count))
	
	locations = fltarr(2,orbit.orbit_summary.one_second_count)
	
	axrat = .99664714532D
	
	
	locations(1,goodtidxs) = 180.0D / double(!PI) * atan(orbit.one_second(goodtidxs).position_vector(1), orbit.one_second(goodtidxs).position_vector(0))
	locations(0,goodtidxs) = 180.0D / double(!PI) * atan(orbit.one_second(goodtidxs).position_vector(2), $
								     axrat*axrat*sqrt(orbit.one_second(goodtidxs).position_vector(0)*orbit.one_second(goodtidxs).position_vector(0) + $
								     			      orbit.one_second(goodtidxs).position_vector(1)*orbit.one_second(goodtidxs).position_vector(1)))
end

