pro flaghelp_alert_summary, lisb

	this_entry = {a_flag_entry, bitnum:byte(0), value:byte(0), condition:' ', description:' '}
	
	alert_summary = replicate(this_entry,8)
	
	alert_summary(0).bitnum 	= 1
	alert_summary(0).value  	= 1
	alert_summary(0).condition = 'F'
	alert_summary(0).description = 'Instrument Fatal'
	
	alert_summary(1).bitnum 	= 2
	alert_summary(1).value  	= 2
	alert_summary(1).condition = 'W'
	alert_summary(1).description = 'Instrument Warning'

	alert_summary(2).bitnum 	= 3
	alert_summary(2).value  	= 4
	alert_summary(2).condition = 'F'
	alert_summary(2).description = 'Platform Fatal'

	alert_summary(3).bitnum 	= 4
	alert_summary(3).value  	= 8
	alert_summary(3).condition = 'W'
	alert_summary(3).description = 'Platform Warning'

	alert_summary(4).bitnum 	= 5
	alert_summary(4).value  	= 16
	alert_summary(4).condition = 'F'
	alert_summary(4).description = 'External Fatal'

	alert_summary(5).bitnum 	= 6
	alert_summary(5).value  	= 32
	alert_summary(5).condition = 'W'
	alert_summary(5).description = 'External Warning'

	alert_summary(6).bitnum 	= 7
	alert_summary(6).value  	= 64
	alert_summary(6).condition = 'F'
	alert_summary(6).description = 'Processing Fatal'

	alert_summary(7).bitnum 	= 8
	alert_summary(7).value  	= 128
	alert_summary(7).condition = 'W'
	alert_summary(7).description = 'Processing Warning'
	
	help_afsb = widget_base(group_leader=lisb,title='Alert Summary Flag')
	help_afs = widget_table(help_afsb,value=alert_summary,column_labels=['BIT','VALUE','W/F','DESCRIPTION'], $
						alignment=1,column_widths=[55,55,55,300])
						
	widget_control,help_afsb,/realize
end

		
pro flaghelp_instrument_alert, lisb

	this_entry = {a_flag_entry, bitnum:byte(0), value:byte(0), condition:' ', description:' '}
	
	instrument_alert = replicate(this_entry,8)
	
	instrument_alert(0).bitnum 	= 1
	instrument_alert(0).value  	= 1
	instrument_alert(0).condition = 'F'
	instrument_alert(0).description = 'Instrument Off'
	
	instrument_alert(1).bitnum 	= 2
	instrument_alert(1).value  	= 2
	instrument_alert(1).condition = 'F'
	instrument_alert(1).description = 'Instrument Reset'

	instrument_alert(2).bitnum 	= 3
	instrument_alert(2).value  	= 4
	instrument_alert(2).condition = 'F/W'
	instrument_alert(2).description = 'FIFO Overflow'

	instrument_alert(3).bitnum 	= 4
	instrument_alert(3).value  	= 8
	instrument_alert(3).condition = 'W'
	instrument_alert(3).description = 'Thresholds Too High'

	instrument_alert(4).bitnum 	= 5
	instrument_alert(4).value  	= 16
	instrument_alert(4).condition = 'F/W'
	instrument_alert(4).description = 'Warm-Up'

	instrument_alert(5).bitnum 	= 6
	instrument_alert(5).value  	= 32
	instrument_alert(5).condition = 'F/W'
	instrument_alert(5).description = 'Bad Temperature'

	instrument_alert(6).bitnum 	= 7
	instrument_alert(6).value  	= 64
	instrument_alert(6).condition = 'F'
	instrument_alert(6).description = 'Packet Gap'

	instrument_alert(7).bitnum 	= 8
	instrument_alert(7).value  	= 128
	instrument_alert(7).condition = '-'
	instrument_alert(7).description = 'No Data Recorded'
	
	help_iab = widget_base(group_leader=lisb,title='Instrument Alert Flag')
	help_ia = widget_table(help_iab,value=instrument_alert,column_labels=['BIT','VALUE','W/F','DESCRIPTION'], $
						alignment=1,column_widths=[55,55,55,300])
						
	widget_control,help_iab,/realize
end

pro flaghelp_platform_alert, lisb

	this_entry = {a_flag_entry, bitnum:byte(0), value:byte(0), condition:' ', description:' '}
	
	platform_alert = replicate(this_entry,8)
	
	platform_alert(0).bitnum 	= 1
	platform_alert(0).value  	= 1
	platform_alert(0).condition = 'W'
	platform_alert(0).description = 'No Att/Eph Quality Flags'
	
	platform_alert(1).bitnum 	= 2
	platform_alert(1).value  	= 2
	platform_alert(1).condition = 'F'
	platform_alert(1).description = 'Ephemeris Unavailable'

	platform_alert(2).bitnum 	= 3
	platform_alert(2).value  	= 4
	platform_alert(2).condition = 'W'
	platform_alert(2).description = 'Poss Bad Ephemeris'

	platform_alert(3).bitnum 	= 4
	platform_alert(3).value  	= 8
	platform_alert(3).condition = 'F'
	platform_alert(3).description = 'Attitude Unavailable'

	platform_alert(4).bitnum 	= 5
	platform_alert(4).value  	= 16
	platform_alert(4).condition = 'W'
	platform_alert(4).description = 'Poss Bad Attitude'

	platform_alert(5).bitnum 	= 6
	platform_alert(5).value  	= 32
	platform_alert(5).condition = 'F'
	platform_alert(5).description = 'Clock Unavailable'

	platform_alert(6).bitnum 	= 7
	platform_alert(6).value  	= 64
	platform_alert(6).condition = 'W'
	platform_alert(6).description = 'Poss Bad Clock'

	platform_alert(7).bitnum 	= 8
	platform_alert(7).value  	= 128
	platform_alert(7).condition = 'F'
	platform_alert(7).description = 'Satellite Off'
	
	help_pab = widget_base(group_leader=lisb,title='Platform Alert Flag')
	help_pa = widget_table(help_pab,value=platform_alert,column_labels=['BIT','VALUE','W/F','DESCRIPTION'], $
						alignment=1,column_widths=[55,55,55,250])
						
	widget_control,help_pa,/realize
end

pro flaghelp_external_alert, lisb

	this_entry = {a_flag_entry, bitnum:byte(0), value:byte(0), condition:' ', description:' '}

	external_alert = replicate(this_entry,8)
	
	external_alert(0).bitnum 	= 1
	external_alert(0).value  	= 1
	external_alert(0).condition = 'W'
	external_alert(0).description = 'Satellite within SAA'
	
	external_alert(1).bitnum 	= 2
	external_alert(1).value  	= 2
	external_alert(1).condition = 'W'
	external_alert(1).description = 'Low Beta Angle'

	external_alert(2).bitnum 	= 3
	external_alert(2).value  	= 4
	external_alert(2).condition = 'W'
	external_alert(2).description = 'Glint Possible'

	external_alert(3).bitnum 	= 4
	external_alert(3).value  	= 8
	external_alert(3).condition = '-'
	external_alert(3).description = 'TMI Off/On'

	external_alert(4).bitnum 	= 5
	external_alert(4).value  	= 16
	external_alert(4).condition = '-'
	external_alert(4).description = 'PR Off/On'

	external_alert(5).bitnum 	= 6
	external_alert(5).value  	= 32
	external_alert(5).condition = '-'
	external_alert(5).description = 'VIRS Off/On'

	external_alert(6).bitnum 	= 7
	external_alert(6).value  	= 64
	external_alert(6).condition = '-'
	external_alert(6).description = 'CERES Off/On'

	external_alert(7).bitnum 	= 8
	external_alert(7).value  	= 128
	external_alert(7).condition = '?'
	external_alert(7).description = '(spare)'
	
	help_eab = widget_base(group_leader=lisb,title='External Alert Flag')
	help_ea = widget_table(help_eab,value=external_alert,column_labels=['BIT','VALUE','W/F','DESCRIPTION'], $
						alignment=1,column_widths=[55,55,55,300])
						
	widget_control,help_eab,/realize
end

pro flaghelp_processing_alert, lisb

	this_entry = {a_flag_entry, bitnum:byte(0), value:byte(0), condition:' ', description:' '}

	processing_alert = replicate(this_entry,8)
	
	processing_alert(0).bitnum 	= 1
	processing_alert(0).value  	= 1
	processing_alert(0).condition = 'W'
	processing_alert(0).description = 'QA Inspector Warning'
	
	processing_alert(1).bitnum 	= 2
	processing_alert(1).value  	= 2
	processing_alert(1).condition = 'F'
	processing_alert(1).description = 'QA Inspector Fatal'

	processing_alert(2).bitnum 	= 3
	processing_alert(2).value  	= 4
	processing_alert(2).condition = 'F'
	processing_alert(2).description = 'Data Too Garbled To Read'

	processing_alert(3).bitnum 	= 4
	processing_alert(3).value  	= 8
	processing_alert(3).condition = 'F'
	processing_alert(3).description = 'Data Too Large to Process'

	processing_alert(4).bitnum 	= 5
	processing_alert(4).value  	= 16
	processing_alert(4).condition = 'W/F'
	processing_alert(4).description = 'Unforseen Error In Processing'

	processing_alert(5).bitnum 	= 6
	processing_alert(5).value  	= 32
	processing_alert(5).condition = 'W'
	processing_alert(5).description = 'Grouping Buffer Saturated'

	processing_alert(6).bitnum 	= 7
	processing_alert(6).value  	= 64
	processing_alert(6).condition = 'W'
	processing_alert(6).description = 'Viewtime Algorithm Failure'

	processing_alert(7).bitnum 	= 8
	processing_alert(7).value  	= 128
	processing_alert(7).condition = '?'
	processing_alert(7).description = '(spare)'
	
	help_prab = widget_base(group_leader=lisb,title='Processing Alert Flag')
	help_pra = widget_table(help_prab,value=processing_alert,column_labels=['BIT','VALUE','W/F','DESCRIPTION'], $
						alignment=1,column_widths=[55,55,55,350])
						
	widget_control,help_prab,/realize
end
	