#include <math.h>
#include "liblisotd_read_LISOTD.h"

/*
struct aCoordArray  array_ij_to_latlon(gpstime)
double gpstime;
{
    struct aCoordArray	LatLon;
    int i, j, ll_return;
    double outlat, outlon;
    extern int spice_lat_lon_();
    
    for (i=0; i<=127; i++) {
	for (j=0; j<=127; j++) {
	    ll_return = spice_lat_lon_(&i,&j,&gpstime,&outlat,&outlon);
	    if (ll_return < 0) {
		LatLon.c1[i][j] = -999;
		LatLon.c2[i][j] = -999;
		goto BREAKIJLL;
	    } else {
		LatLon.c1[i][j] = RAD2DEG(outlat);
		LatLon.c2[i][j] = RAD2DEG(outlon);
		if (LatLon.c2[i][j] > 180.0) LatLon.c2[i][j] -= 360.0;
	    }
	}
    }
BREAKIJLL:    return(LatLon);
}

struct aCoordArray  array_latlon_to_rgaz(LatLon, Position, min_rg)
struct aCoordArray  LatLon;
struct aLatLonPair  Position;
double *min_rg;
{
    struct aCoordArray	RgAz;
    int	i, j;
    double rg, az1, az2,  min_az = 999;
    extern void LatLons2RgAz();
    
    *min_rg = 1e9;

    if (LatLon.c1[0][0] == -999) {
	*min_rg = 1e9;
	min_az = 1e9;
	RgAz.c1[0][0] = 1e9;
	RgAz.c2[0][0] = 1e9;
	goto BREAKLLRA;
    }
    for (i=0; i<=127; i++) {
	for (j=0; j<=127; j++) {
	    LatLons2RgAz( Position.Latitude, Position.Longitude, 
		    (double)LatLon.c1[i][j], (double)LatLon.c2[i][j], 
		    &az1, &az2, &rg);
	    RgAz.c1[i][j] = (double)rg/1e3;
	    RgAz.c2[i][j] = (double)az1;
            
	    if (rg < *min_rg) {
		*min_rg=rg;
		min_az = az1;
	    }
	}
    }	
    *min_rg /= 1e3;

BREAKLLRA:    return(RgAz);
}

struct aCoordArray  array_latlon_to_xy(LatLon, Pos)
struct aCoordArray  LatLon;
struct aLatLonPair  Pos;
{
    struct aCoordArray	XY;
    int i, j;
    double  lat0, lon0, lat1, lon1;
    double  az1, az2, x, y, min_absx = 1e9, min_absy = 1e9;
    extern void LatLons2RgAz();
    
    lat0 = Pos.Latitude;
    lon0 = Pos.Longitude;
    
    for (i=0; i<=127; i++) {
	for (j=0; j<=127; j++) {
	    
	    lat1 = (double)LatLon.c1[i][j];
	    lon1 = (double)LatLon.c2[i][j];
	    LatLons2RgAz(lat0, lon0, lat0, lon1, &az1, &az2, &x);
	    if (az1 > 180) x *= (-1.0);
	    LatLons2RgAz(lat0, lon0, lat1, lon0, &az1, &az2, &y);
	    if ((az1 > 90) && (az2 < 270)) y *= (-1.0);
	    
	    XY.c1[i][j] = x/1e3;
	    XY.c2[i][j] = y/1e3;
	    
	}
    }

    return(XY);
}
*/
void LatLons2RgAz(double dglat1, double dglon1,

            double dglat2, double dglon2,
            double *faz, double *baz, double *s)
{
static double r,tu1,tu2,cu1,su1,cu2,x,sx,cx,sy,cy,y,sa,c2a,cz,e,c,d;
static double glat1, glat2, glon1, glon2;
double testrg, conv;

 testrg = EARTH_RADIUS*acos(sin(D2R*dglat1)*sin(D2R*dglat2)+
		cos(D2R*dglat1)*cos(D2R*dglat2)*cos(fabs(D2R*dglon1-D2R*dglon2)));

 if ( (dglat1 == dglat2) && (dglon1 == dglon2))
    {
    *s = 0;
    *faz = 0;
    *baz = 0;
    }
  else
    {
    glat1 = radians(dglat1);
    glat2 = radians(dglat2);
    glon1 = radians(dglon1);
    glon2 = radians(dglon2);

    r = 1.0-Fe;
    tu1 = r*sin(glat1)/cos(glat1);
    tu2 = r*sin(glat2)/cos(glat2);



    cu1 = 1.0/sqrt(tu1*tu1+1.0);
    su1 = cu1*tu1;
    cu2 = 1.0/sqrt(tu2*tu2+1.0);
    *s = cu1*cu2;
    *baz = *s*tu2;
    *faz = *baz*tu1;
    x = glon2-glon1;
    if (testrg > 19000.) {
	conv = 1e-1;
    } else {
        conv = 1e-6;
    }
     do
       {
       sx = sin(x);
       cx = cos(x);
       tu1 = cu2*sx;
       tu2 = *baz-su1*cu2*cx;
       sy = sqrt(tu1*tu1+tu2*tu2);
       cy = *s*cx+*faz;
       y = Atan2(sy,cy);
       sa = *s*sx/sy;
       c2a = -(sa*sa)+1.0;
       cz = *faz+*faz;
       if(c2a > 0.0) cz = -(cz/c2a)+cy;
       e = cz*cz*2.0-1.0;
       c = ((-3.0*c2a+4.0)*Fe+4.0)*c2a*Fe/16.0;
       d = x;
       x = ((e*cy*c+cz)*sy*c+y)*sa;
       x = (1.0-c)*x*Fe+glon2-glon1;
       }
       while (fabs(d-x) > conv) ;

    *faz = degrees(Atan2(tu1,tu2));
      while ( *faz <   0.0 )  *faz += 360.0 ;
      while ( *faz > 360.0 )  *faz -= 360.0 ;

    *baz = degrees(Atan2(cu1*sx,*baz*cx-su1*cu2)+Pi);
      while ( *baz <   0.0 )  *baz += 360.0 ;
      while ( *baz > 360.0 )  *baz -= 360.0 ;

    x = sqrt((1.0/r/r-1.0)*c2a+1.0)+1.0;
    x = (x-2.0)/x;
    c = 1.0-x;
    c = (x*x/4.0+1.0)/c;
    d = (0.375*x*x-1.0)*x;
    x = e*cy;
    *s = 1.0-e-e;
    *s = ((((sy*sy*4.0-3.0)**s*cz*d/6.0-x)*d/4.0+cz)*sy*d+y)*c*Ae*r;
   }
}

void RgAz2LatLon(double  dglat1, double  dglon1,
            double *dglat2, double *dglon2,
            double  dfaz, double  *baz, double s )
{
static double  r,tu,sf,cf,cu,su,sa,c2a,x,c,d,y,sy,cy,cz,e;
static double glat1, glon1,faz;
    glat1 = radians(dglat1);
    glon1 = radians(dglon1);
    faz   = radians(dfaz);

    r = 1.0-Fe;
    tu = r*sin(glat1)/cos(glat1);
    sf = sin(faz);
    cf = cos(faz);
    *baz = 0.0;
    if(cf != 0.0) *baz = Atan2(tu,cf)*2.0;
    cu = 1.0/sqrt(tu*tu+1.0);
    su = tu*cu;
    sa = cu*sf;
    c2a = -(sa*sa)+1.0;
    x = sqrt((1.0/r/r-1.0)*c2a+1.0)+1.0;
    x = (x-2.0)/x;
    c = 1.0-x;
    c = (x*x/4.0+1.0)/c;
    d = (0.375*x*x-1.0)*x;
    tu = s/r/Ae/c;
    y = tu;

    do
      {
      sy = sin(y);
      cy = cos(y);
      cz = cos(*baz+y);
      e = cz*cz*2.0-1.0;
      c = y;
      x = e*cy;
      y = e+e-1.0;
      y = (((sy*sy*4.0-3.0)*y*cz*d/6.0+x)*d/4.0-cz)*sy*d+tu;
      }
      while (fabs(y-c) > EPS);

    *baz = cu*cy*cf-su*sy;
    c = r*sqrt(sa*sa+*baz**baz);
    d = su*cy+cu*sy*cf;
    *dglat2 = degrees(Atan2(d,c));
      while ( *dglat2 > 180.0 )  *dglat2 -= 360.0 ;
    c = cu*cy-su*sy*cf;
    x = Atan2(sy*sf,c);
    c = ((-3.0*c2a+4.0)*Fe+4.0)*c2a*Fe/16.0;
    d = ((e*cy*c+cz)*sy*c+y)*sa;
    *dglon2 = degrees(glon1+x-(1.0-c)*d*Fe);
      while ( *dglon2 <   0.0 )  *dglon2 += 360.0 ;
      while ( *dglon2 > 360.0 )  *dglon2 -= 360.0 ;
    *baz = degrees(Atan2(sa,*baz)+Pi);
      while ( *baz <   0.0 )  *baz += 360.0 ;
      while ( *baz > 360.0 )  *baz -= 360.0 ;
    if (*dglon2 > 180.0) {
    	*dglon2 -= 360.0;
    	
    }
}


double atan2 ( double y, double x)
{
double xx;


if ( x == 0.0 )
        {
        if ( y == 0.0 )
                {
                xx = 0.0 ;
                }
                else
                {
                if ( y > 0.0 )  {
                        xx =    PI/2.0 ;
                        }
                        else    {
                        xx =   -PI/2.0 ;
                        }
                }
        }
        else
        {
        if ( y == 0.0 )
                {
                if ( x > 0.0 )  {
                        xx = 0.0;
                        }
                        else    {
                        xx = PI;
                        }
                }
                else
                {
                xx =  atan( fabs(y)/ fabs(x) )  ;
                if ( x > 0.0 )
                        {
                        if ( y > 0.0 )  {
                                xx = xx ;
                                }
                                else    {
                                xx  = -xx ;
                                 }
                        }
                        else
                        {
                        if ( y > 0.0 )  {
                                xx =  PI - xx ;
                                 }
                                else    {
                                xx =  PI + xx ;
                                }

                        }
                }

        }

while ( xx > 2*PI ) xx -= 2*PI;
while ( xx < 0.0  ) xx += 2*PI;
return(xx);
}


