#include <stdio.h>
#include <stdlib.h>
#include "liblisotd_read_LISOTD.h"
#include <string.h>
#include <ctype.h>

int 
strcasecmp(
           const char *str1, 
           const char *str2
           )
{
    int diff;

    for (; *str1 && *str2; str1++, str2++) {
        diff = toupper(*str1) - toupper(*str2);
        if (diff != 0) {
            return (diff);
        }
    }
    return (0);
}

int 
strncasecmp(
            const char *str1, 
            const char *str2, 
            unsigned nchars
            )
{
    int i;
    int diff;

    for (i = 0; i < nchars && *str1 && *str2; i++, str1++, str2++) {
        diff = toupper(*str1) - toupper(*str2);
        if (diff != 0) {
            return (diff);
        }
    }
    if (i == nchars) {
        return (0);
    }
    if (*str1 == 0) {
        return (-1);
    } else {
        return (1);
    }
}



char 	RawFilePath[132];
char	OutFilePath[132];

void GetFileSize(tmpfile, nl)
FILE *tmpfile;
long *nl;
{
	char aline[132];
	extern int fgetaline();
	
	rewind(tmpfile);
	*nl = 0;
	while (fgetaline(aline, 132, tmpfile)) {
	    *nl += 1;
	}
		    
	printf("%ld lines in file.\n", *nl);
}

int fgetaline(s, lim, afile)
char s[];
int lim;
FILE *afile;
{
   int c,i;
   i=0;
   while (--lim>0 && (c=fgetc(afile)) !=EOF && c != '\n')
      s[i++] = c;
   if (c == '\n')
      s[i++] = c;
   s[i] = '\0';
   s[i-1] = '\0';
   return(i);
}

FILE *OpenStream(filename)
char filename[132];
{
    FILE *outfile;
    extern int strncasecmp();

    if (!strncasecmp(filename, STDOUT, 6)) {
	outfile = stdout;
    } else if (!strncasecmp(filename, STDERR, 6)) {
	outfile = stderr;
    } else {
    	if ((outfile = fopen(filename, "w"))==NULL) {
	    fprintf(stderr, "Error opening file %s for output.\n");
	    exit(-1);
	}
    }    
    return(outfile);
}

void CloseStream(outfile)
FILE *outfile;
{
    if ((outfile != stdout) && (outfile != stderr)) fclose(outfile);
    return;
}

union aFileID OpenFileID(output_type, filename0, dump_flags, platform)
int	output_type;
char	filename0[132];
int	dump_flags[5];
char platform[4];
{
    union   aFileID	OutID;
    extern  char OutFilePath[132];
    char    filename[132];

    sprintf(filename,"%s%s",OutFilePath,filename0);

    switch(output_type) {
        case METADATA:
	    { 
		sprintf(OutID.name[M], "%s.meta", filename);
		OutID.out_stream[M] = OpenStream(OutID.name[M]);
	        break;
	    }
	case ASCII_TREE:
	    {
		sprintf(OutID.name[T], "%s.", filename);
		if (dump_flags[O]) strcat(OutID.name[T], "o");
		if (dump_flags[A]) strcat(OutID.name[T], "a");
		if (dump_flags[F]) strcat(OutID.name[T], "f");
		if (dump_flags[G]) strcat(OutID.name[T], "g");
		if (dump_flags[E]) strcat(OutID.name[T], "e");
		OutID.out_stream[T] = OpenStream(OutID.name[T]);
		break;
	    }
	case ASCII_SINGLE:
	    {
		if (dump_flags[O]) {
		    sprintf(OutID.name[O], "%s.o", filename);
		    OutID.out_stream[O] = OpenStream(OutID.name[O]);
		}
		if (dump_flags[A]) {
		    sprintf(OutID.name[A], "%s.a", filename);
		    OutID.out_stream[A] = OpenStream(OutID.name[A]);
		}
		if (dump_flags[F]) {
		    sprintf(OutID.name[F], "%s.f", filename);
		    OutID.out_stream[F] = OpenStream(OutID.name[F]);
		}
		if (dump_flags[G]) {
		    sprintf(OutID.name[G], "%s.g", filename);
		    OutID.out_stream[G] = OpenStream(OutID.name[G]);
		}
		if (dump_flags[E]) {
		    sprintf(OutID.name[E], "%s.e", filename);
		    OutID.out_stream[E] = OpenStream(OutID.name[E]);
		}
		break;
	    }
	case BINARY:
	    {
		if (dump_flags[A]) {
		    sprintf(OutID.name[A], "%s.a.bin", filename);
		    OutID.out_stream[A] = OpenStream(OutID.name[A]);
		}
		if (dump_flags[F]) {
		    sprintf(OutID.name[F], "%s.f.bin", filename);
		    OutID.out_stream[F] = OpenStream(OutID.name[F]);
		}
		if (dump_flags[G]) {
		    sprintf(OutID.name[G], "%s.g.bin", filename);
		    OutID.out_stream[G] = OpenStream(OutID.name[G]);
		}
		if (dump_flags[E]) {
		    sprintf(OutID.name[E], "%s.e.bin", filename);
		    OutID.out_stream[E] = OpenStream(OutID.name[E]);
		}
		break;
	    }
	case MINI_HDF:
	    {
	    if (!strcmp(platform,"OTD")) {
			sprintf(OutID.name[T], "%s.mlab", filename);
			if ((OutID.hdf_id = create_OTD_HDF_FILE(OutID.name[T]))==FAIL) {
			    fprintf(stderr, "Error creating Mini-HDF file %s\n", 
				    OutID.name[T]);
			    exit(-1);
			}
		} else {
			sprintf(OutID.name[T],"%s.SC",filename);
			if ((OutID.hdf_id = create_LIS_ORBIT_HDF(filename))==FAIL) {
				fprintf(stderr,"Error creating LIS Mini-HDF file %s\n",
					OutID.name[T]);
				exit(-1);
			}
		}
		break;
	    }

	case SDS:
	    {
		break;
	    }
    }
    
    return(OutID);
}

void CloseFileID(OutID, output_type, dump_flags)
union   aFileID	OutID;
int	output_type;
int	dump_flags[5];
{   
    switch(output_type) {
	case METADATA:
	    {
		CloseStream(OutID.out_stream[M]);
		break;
	    }
	case ASCII_TREE:
	    {
		CloseStream(OutID.out_stream[T]);
		break;
	    }
	case BINARY:
	case ASCII_SINGLE:
	    {
		if (dump_flags[O]) CloseStream(OutID.out_stream[O]);
		if (dump_flags[A]) CloseStream(OutID.out_stream[A]); 
		if (dump_flags[F]) CloseStream(OutID.out_stream[F]);
		if (dump_flags[G]) CloseStream(OutID.out_stream[G]);
		if (dump_flags[E]) CloseStream(OutID.out_stream[E]);
		break;
	    }
	case MINI_HDF:
	    {
		/* close_OTD_HDF_FILE(); */
		break;
	    }
	case SDS:
	    {
		break;
	    }
	    
    }
    
    return;
}

void SetRawFilePath(filepath)
char *filepath;
{
	extern char RawFilePath[132];
	strcpy(RawFilePath,filepath);
}

void SetOutFilePath(filepath)
char *filepath;
{
	extern char OutFilePath[132];
	strcpy(OutFilePath,filepath);
}
